#!/usr/bin/perl
#######################################################################
# Ce script en Perl fabrique des images via Rrdtool et la commande 
# "ntpdc -c rv 192.168.1.10" (exemple) 
# Necessite la lib suivante : "librrds-perl" + "rrdtool"
# A utiliser dans la crontab : 
# "0,5,10,15,20,25,30,35,40,45,50,55 * * * *	root	/opt/NTP-STATS/ntp-graphe.pl localhost &"
# Ce script necessite 1 ou 2 repertoires, a vous de voir.
# Pour eviter l'installation de trop de dependance, pas de fonction "pod"... donc l'aide
# est livre à la fin de ce fin fichier (pas d'option  ce niveau).
######################################################################
use strict ;
use RRDs;

# Le repertoire ou vont se trouver le programme + les graphes
# Ces 2 rep peuvent etre differents (!)
# stockage du fichier RRD, fichier OUT ... 
my $reptravail	= "/var/www/localhost/htdocs/ntpgraffe/scripts/" ;
# stockage des graphes 
my $repdiff	= "/var/www/localhost/htdocs/ntpgraffe/scripts/" ;
#
# ------------- Nom de la base RRD
my $serveur = $ARGV[0];   # recupere l'@ IP du destinataire
my $fich_RRD = $reptravail ."sts-" .$ARGV[0] .".rrd" ; # nom du fichier RRD
#--------------------------------------------------------------
# Les version recentes de ntp ne renvoient plus les parametres :
# "noise" + "stability" (??? dommage)
# Il faut donc prendre en charge pour eviter la generation d'images vides
my $restrict = $ARGV[1];   #  correspond a la 2eme valeur passee en option, pas de test
#                             donc n'importe quelle valeur.
#--------------------------------------------------------------
my $version =" $0 version 2.1.0 (AVRIL 2010) sous licence (GPL version 2) $\n";
# pour affichage de l'heure dans les graphes
my ($heure, $minute, $jour, $mois, $an) = (localtime)[2,1,3,4,5];#
    $an += 1900 ;
    $mois += 1 ;
if (length($heure) == 1) { $heure = "0" .$heure; }
if (length($minute) == 1) { $minute = "0" .$minute; }
if (length($mois) == 1) { $mois = "0" .$mois; }

# Mise en forme pour l'affichage de la date/heure dans les graphes
my $majtime = "$jour-"."$mois-"."$an $heure". "H". "$minute";

use vars qw ($i $cmd $create $name $fichier $ver $reftime $clock) ;

my  @parametres = ($serveur, $fich_RRD, $majtime, $repdiff, $reftime, $clock);


#------ Fin PARTIE CONFIGURABLE VARIABLES ---------------
#
#--------- Fonction-CREATE RRDs (1) --
sub create_rrd {
# 4 valeurs - Valeur MAX demandee
#DS:Local:GAUGE:300:U:U pour type GAUGE toutes les 300s(5 mn)
#
	RRDs::create ($_[0] , 
		"--step","300",
		"DS:offset:GAUGE:600:U:U",
		"DS:jitter:GAUGE:600:U:U",
		"DS:noise:GAUGE:600:U:U",
		"DS:stabilite:GAUGE:600:U:U",
		"DS:freq:GAUGE:600:U:U",
		
		"RRA:AVERAGE:0.5:1:600",
		"RRA:AVERAGE:0.5:1:1200",
		"RRA:AVERAGE:0.5:5:2400",
		
		"RRA:LAST:0.5:1:1200",
		
		"RRA:MAX:0.5:1:1200",
		
		"RRA:MIN:0.5:1:1200"
	);

	if (RRDs::error) {
	print RRDs::error ."\nImpossible de creer le fichier `$_[0]'\n" ;
	exit(1);
	} else { print "Creation du fichier `$_[0]' = [Ok]\n" ; }
exit(1);
}
#-------------- Fin fonction---------------
##############################################
sub OutTempFile {
my $file;
	my $RfTab = $_[1];
	my @Rfval = @$RfTab;

	$file = $Rfval[3].$Rfval[0].".out" ;

	if ($cmd =~ /PROBLEME:/) { 
		$file = $Rfval[3]."problem-".$Rfval[0].".out" ; 
	} else {
		$file = $Rfval[3].$Rfval[0].".out" ;
		unlink $Rfval[3]."problem-".$Rfval[0].".out";   # Efface le fichier "PROBLEM..." 
	}

   		$cmd =~ s/ status/\nstatus/g ;
   		$cmd =~ s/,/\n/g ;
   		$cmd =~ s/\n\n/\n/g ;
		print "fichier $file";
		open (OUTFILE, "> $file") or
  		die "Desole, impossible d'ecrire dans $file...\n$!\n";

	print OUTFILE $_[0];
	close OUTFILE;
}
##############################################
sub MiseAJour {
# Fonction avec X passages de parametres via les $_...
# MiseAJour ("offset", $type,\@valeursNTP, \@parametres );
# Recuperation d'un tableau passe en parametre
# (2 tableaux en realite)
##############################################
my $RefTab = $_[2];
my @RefvaleursNTP = @$RefTab;

# 2eme tableau :
$RefTab = $_[3];
my @Refparametres = @$RefTab;
##############################################

my $fich_png ; my $lign;
my $xpts 	= "420"; # larg  420
my $ypts 	= "151"; # hauteur 101
my @typegraph = (
                { titre => '24H',       decal => '24h',},
                { titre => 'Semaine',   decal => '7d' ,},
                { titre => 'Mois',      decal => '30d' ,},
                { titre => '6 Mois',    decal => '180d' ,},
                );

# Titre du graphe
my $title	= "NTP-($_[0])-$Refparametres[0]-".$typegraph[$_[1]]{titre} ;
# print "le Titre $title \n";

# vaste choix de couleurs ... :
my %color = (
        a => "3CE63C",	#vert
        b => "FFCC00",	#orange
        c => "FFFED7",	#bleu clair
        d => "A800FF",	#bleu fonce
        e => "0008FF",	#bleu
        f => "038E00",	#vert fonce
        g => "FF0000",	#rouge
        h => "FFC4C4",	#rouge clair
        i => "010101",	#noir

        j => "8E8E8E",	#Fond gris
        k => "000000",	#Trais noirs
        l => "E5F6FF",	#contour bleue
        
	    offset    => "feffe4",	# fond jaune C
        jitter    => "e8e4ff",	# fond bleu/violet C
        noise     => "D4FFE5",	# fond vert C
        stabilite => "FFEFC5",	# fond orange C
        freq      => "C6C6C6"   # fonc gris C
        );
######################################################
# traits gros au debut puis fin ensuite
if ($_[1] == 0 ) { $fich_png = $Refparametres[3].$Refparametres[0]."-$_[0]-J.png" ; 
		$lign='LINE2:nval#'.$color{g}.':'; } 
if ($_[1] == 1 ) { $fich_png = $Refparametres[3].$Refparametres[0]."-$_[0]-S.png" ; 
		$lign='LINE1:nval#'.$color{g}.':'; }
if ($_[1] == 2 ) { $fich_png = $Refparametres[3].$Refparametres[0]."-$_[0]-M.png" ; 
		$lign='LINE1:nval#'.$color{g}.':'; }
if ($_[1] == 3 ) { $fich_png = $Refparametres[3].$Refparametres[0]."-$_[0]-A.png" ; 
		$lign='LINE1:nval#'.$color{g}.':'; }

# Creation du graphe :

		RRDs::graph ( $fich_png,
		"--imgformat=PNG",		# ou GIF
		"--start", "-$typegraph[$_[1]]{decal}",
		"--alt-autoscale",
		"--width","$xpts",
		"--height","$ypts",
		"--rigid",			
		"--title", "$title",
		"--color","SHADEA#$color{j}",       # pourtour Droite
		"--color","SHADEB#$color{k}",       # pourtour Gauche
		"--color","BACK#$color{$_[0]}",     # Fond de l'image
	
		"DEF:nval=$Refparametres[1]:$_[0]:LAST",
		"DEF:aval=$Refparametres[1]:$_[0]:AVERAGE",
		"DEF:mval=$Refparametres[1]:$_[0]:MAX",
		"DEF:pval=$Refparametres[1]:$_[0]:MIN",
		
		"$lign",
		
		'GPRINT:nval:LAST:Val    \: %6.5lf    ',
		'GPRINT:mval:MAX:Max(+) \: %6.5lf\\n',
		'GPRINT:aval:AVERAGE:Moy    \: %6.5lf    ',
		'GPRINT:pval:MIN:Max(-) \: %6.5lf \\n',
	
		"COMMENT:-----------------------------------------------------------\\n",
		"COMMENT:Version $RefvaleursNTP[5] \/ CPU $RefvaleursNTP[6] \/ $RefvaleursNTP[13]\\n",
		"COMMENT:Stratum $RefvaleursNTP[11] \/ Status $RefvaleursNTP[14] \/ REFID $RefvaleursNTP[12]\\n",
		"COMMENT:Reftime $RefvaleursNTP[9] \/ Clock $RefvaleursNTP[10]\\n",
		"COMMENT:Cert(1) $RefvaleursNTP[15] \/ Flag $RefvaleursNTP[17] \/ Exp $RefvaleursNTP[18] \\n",
		"COMMENT:Group $RefvaleursNTP[19] \/ Sync $RefvaleursNTP[7] \/ Event $RefvaleursNTP[8]\\n",
		"COMMENT:-----------------------------------------------------------\\g",
		"COMMENT:               Mise a jour le $Refparametres[2] \\g"
		
	);	
		if (RRDs::error) { print RRDs::error ;
			   print "\nERREUR avec RRDs et $fich_png\n " ;
	 	} 

}	
# ----------------------------------------------------------------------
	# Si le fichier .rrd n est pas present ...
	if (not -f $fich_RRD) { create_rrd($fich_RRD) ; }
#-------------------------------------------------

# # Lancement de  commande ntpdc ...
my @retourCMD = () ;
$cmd = `ntpq -c rv $ARGV[0]`;
# $cmd = `ntpq -c rv 127.0.0.1`;  # peut servir, on ne sait jamais ...

   if ((!$cmd) || ($cmd =~ /timed out/)) { 
   		print "Probleme avec NTPQ...\n" ; 
		$cmd = "PROBLEME: Le serveur n'est pas joignable via la commande ntpq"; # ne pas supprimer le mot 'probleme', il est recherche apres ..
		OutTempFile ( $cmd, \@parametres );
		exit(1) ; } 
	
   	$cmd =~ s/(,\scert)/,CRT/ ;
	$cmd =~ s/(,\suntil)/,CRT-until/ ;
	
	$cmd =~ s/reftime=[a-z0-9.]{1,}\s/,reftime=/ ;
	$cmd =~ s/clock=[a-z0-9.]{1,}\s/,clock=/ ;
	$cmd =~ s/version="ntpd\s([a-z0-9.]{1,})@.*,/version=$1/ ;
	$cmd =~ s/(processor=)/,processor=/ ;

   	$cmd =~ s/\n//g ;
   	$cmd =~ s/"//g ;
   	# $cmd =~ s/:/\//g ; # remplace : par /
   	$cmd =~ s/:/./g ;    # remplace : par . 
	
	$cmd =~ s/\s([a-zA-Z]{1,}),/$1/g ;
	
	@retourCMD = split(/,/,$cmd) ;

my @valeursNTP = ();

	# la bouche de filtrage / extraction de donnees ...
	foreach (@retourCMD) {
	
   	if ( /offset=([0-9-.]{1,})/)    { $valeursNTP[0] = $1;}
   	if ( /frequency=([0-9-.]{1,})/) { $valeursNTP[1] = $1;}
   	if ( /jitter=([0-9-.]{1,})/)    { $valeursNTP[2] = $1;}
   	if ( /noise=([0-9-.]{1,})/) 	{ $valeursNTP[3] = $1;}
   	if ( /stability=([0-9-.]{1,})/) { $valeursNTP[4] = $1;} 

   	if ( /version=(.*)/) 		  { $valeursNTP[5] = $1;}
   	if ( /processor=((.*))/)	  { $valeursNTP[6] = $1;}
   	if ( /sync_([a-z0-9_]{1,})/) 	  { $valeursNTP[7] = $1;}
   	if ( /1event\s([a-z0-9_\/]{1,})/) { $valeursNTP[8] = $1;}
   	
	if ( /reftime=(\w+\s\w+\s)(.*)/)   { $valeursNTP[9] = $2;}
	if ( /clock=(\w+\s\w+\s)(.*)/)   { $valeursNTP[10] = $2;}
   	
   	if ( /stratum=(\d+)/) 			   { $valeursNTP[11] = $1;}
   	if ( /refid=([a-zA-Z0-9\.\(\)]{1,})/)      { $valeursNTP[12] = $1;}
   	if ( /system=([\/a-zA-Z0-9\.\(\)]{1,})/)   { $valeursNTP[13] = $1;}
   	if ( /status=(\d+)/) 	   		   { $valeursNTP[14] = $1;}  # anciennement pool qui a disparu (?)
   	
   	if ( /CRT=([a-zA-Z0-9\.\s]{1,})/) 	{ $valeursNTP[15] = $1;}  # 1er certificat
   	if ( /CRT-until=(\d\d\d\d)(\d\d)(\d\d)(\d+)/) { $valeursNTP[18] = "$3-$2-$1 $4";}   #date d'expiration 
   	# if ( /cert=([a-zA-Z0-9\.\s]{1,})/) 	{ $valeursNTP[20] = $1;} #2eme certificat...
   	# if ( /until=(\d\d\d\d)(\d\d)(\d\d)(\d+)/) { $valeursNTP[21] = "$3-$2-$1 $4";}   # date d'expiration

   	# if ( /update=(\d\d\d\d)(\d\d)(\d\d)(\d+)/) { $valeursNTP[16] = "$3-$2-$1 $4";} # heure MAJ cle; est-ce important
   	
	if ( /flags=([a-z0-9]{1,})/) { $valeursNTP[17] = "[$1]";}
	if ( /group=([a-zA-Z0-9]{1,})/) { $valeursNTP[19] = "[$1]";}

	}

	# print "$cmd \n CRT=$valeursNTP[20]\n"; # pour debug

#----------------------------------------------------------
my $type=() ;
# Mise a jour des donnees - journee/semaine/mois/annee (type)

	RRDs::update $fich_RRD,"N:$valeursNTP[0]:$valeursNTP[2]:$valeursNTP[3]:$valeursNTP[4]:$valeursNTP[1]";
	if (RRDs::error) { print "RRDs::error Mise a jour impossible de $fich_RRD\n"; }

$type = 0 ;	

if (( $minute >= "0" ) and ( $minute < "4" )) {      # toutes les heures mets a jour TOUT
	while ($type < 4) {

		MiseAJour ("offset", $type,\@valeursNTP, \@parametres ) ;
		MiseAJour ("freq", $type, \@valeursNTP, \@parametres ) ;
		MiseAJour ("jitter", $type, \@valeursNTP, \@parametres ) ;
		MiseAJour ("noise", $type, \@valeursNTP, \@parametres ) if (!$restrict);
		MiseAJour ("stabilite", $type, \@valeursNTP, \@parametres ) if (!$restrict);
		# Outtempfile( $cmd, \@parametres );
		$type++ ;
		} 
} else {
	        # ne mets a  jour que le graphe "journalier" 
		MiseAJour ("offset", $type,\@valeursNTP, \@parametres ) ;
		MiseAJour ("freq", $type, \@valeursNTP, \@parametres ) ;
		MiseAJour ("jitter", $type, \@valeursNTP, \@parametres ) ;
		MiseAJour ("noise", $type, \@valeursNTP, \@parametres ) if (!$restrict);
		MiseAJour ("stabilite", $type, \@valeursNTP, \@parametres ) if (!$restrict);
		OutTempFile ( $cmd, \@parametres );

}
# ----------------------------------------------------------------------
__END__
# ----------------------------------------------------------------------
=head1 NAME
	ntp-graphe.pl interroge un serveur NTP puis procde  la cration de plusieurs graphiques de supervision via Rddtool.
	Ce script peut interroger a distance plusieurs serveurs NTP.

=head1 SCRIPT CATEGORIES

	UNIX/MAIL
		Statistique

=head1 SYNOPSIS

	C<./ntp-graphe.pl localhost> Interroge le serveur NTP local (127.0.0.1 reste valable aussi)
	C<./ntp-graphe.pl 192.168.1.5> Interroge le serveur NTP à l'adresse désignée.
	C<./ntp-graphe.pl 192.168.1.5 new> Interroge le serveur NTP à l'adresse désignée, et ne créé pas les 2 graphes dont les
	paramètres ne sont plus renvoyés par NTP (dans les versions récentes).
	C<./ntpgraphe.pl localhost new> avec 2 options transmises, permet de ne pas prendre en les parametres
					"noise" et "stability" qui n'existe plus sur les versions récentes de NTPD.

=head1 DESCRIPTIONS
	ntp-graphe.pl utilise cette commande pour recevoir des parametres :
	C<$cmd = `ntpq -c rv $ARGV[0]`;> . Ensuite il mets en forme toutes ses données dans plusieurs graphiques via Rddtool.
	Beaucoup de paramètres sont réglables à l'interieur du script...comme la durée, les couleurs, la grosseur de l'image.
	- le fichier de données se terminant par ".rrd" est la base de données RRDTOOL, elle est précieuse.

=head1 UTILISATION

	A employer dans la contab (avec mises a jour via Rrtool toutes les 5 minutes :
	0,5,10,15,20,25,30,35,40,45,50,55 * * * *	root	/opt/NTP-STATS/ntp-graphe.pl localhost new 2&>1 > /dev/null

	La 1ere fois le script fabrique le fichier .rrd (Round Robin Database) et c'est tout (!!!). La 2eme fois, les graphiques doivent
	apparaitres...
	
=head1 PREREQUISITES

	use RRDs        Pour la partie graphique (RRDTool), fait partie de RRDTool (a installer)
			Disponible ici : http://oss.oetiker.ch/rrdtool/download.en.html
			La librairie pour Perl est dispo dans toutes les distrib, sinon ici à compiler :
			http://search.cpan.org/~mschilli/RRDTool-OO-0.30/
			Rien de compliquer (!)
	
	Les données à régler au début/avant :

	my $reptravail	= "/opt/NTP-STATS/" ; # désigne le répertoire ou sont stockés les images.  
	my $repdiff	= "/opt/NTP-STATS/" ; # désigne le répertoire ou est stocké le fichier RRD.
	# ---- Nom de la base RRD, c'est aussi modifiable sans problème, il faut éviter de retirer la valeur $ARGV,
	c'est elle qui différencie les fichiers RRD en fonction des serveurs NTP intérrogés (!).
	my $fich_RRD = $reptravail ."sts-" .$ARGV[0] .".rrd" ; # nom du fichier RRD

	Important : pour chaque serveur la commande "ntpq" doit être accessible. Il n'est donc pas nécessaire de faire tourner
			ce script en tant que "root".

=head1 COPYRIGHT

	Copyright (c) 2009-2010 laurent.archambault <archi.laurent@gmail.com>.
	Tout droits reserves.
	Ce programme est sous licence GPL version 2. 
	Vous pouvez le modifier/distribuer sous les termes de la GPL.

=head1 REVISION
	ntp-graphe v2.0 du 25/10/2010
	Les versions précédentes ont été peu diffusé, cette version apporte beaucoup de modification au niveau du code, et des graphes.
	ntpgraphe v2.1 du 25 avril 2010 : apporte l'affichage de plusieurs CERT et des dates d'experations... affiche aussi le group

	$Id: ntp-graphe.pl v2.0 du 25/10/2010 laurent.archambault archi.laurent@gmail.com$

=cut

