#!/usr/bin/perl
#######################################################################
# Ce script en Perl fabrique un fichier XML avec les données renvoyées de 
# la commande "ntpdc -c peers 192.168.1.10" (exemple) 
# Necessite la lib : aucune !
# A utiliser dans la crontab : (a votre convenance) 
# "0,30 * * * *	root	/opt/NTP-STATS/ntp-peers.pl localhost &"
# Ce script necessite 1 pour y écrire son fichier .
# Sous licence GPL - 2010 - Archi.laurent@gmail.com
######################################################################
use strict ;
use Switch;
# Le repertoire ou vont se trouver le fichier XML
# A laisser vide si le script est deja dans le repertoire ou est exploite le fichier de sortie (XML)
# attention a la crontab (!) ...
my $reptravail	= "/var/www/localhost/htdocs/ntpgraffe/scripts/" ;
# ------------- Nom du fichier "peers" en sortie..
my $fich_PEERS = $reptravail."peers-" .$ARGV[0] .".xml" ; # nom du fichier RRD
#--------------------------------------------------------------
#--------------------------------------------------------------
my $version =" $0 version 1.0 (MAI 2010) sous licence (GPL version 2) $\n";
#------ Fin PARTIE CONFIGURABLE VARIABLES ---------------
#
##############################################
#-------------------------------------------------

# # Lancement de  commande ntpdc ...

my $cmd = `ntpq -c peers $ARGV[0]`;  # la commande "lpeers" est similaire.
# my $cmd = `ntpq -c rv 127.0.0.1`;  # peut servir, on ne sait jamais ...

if ((!$cmd) || ($cmd =~ /unreachable/)) { 
   		print "Probleme avec NTPQ...\n" ; 
		$cmd = "PROBLEME: Le serveur n'est pas joignable via la commande ntpq"; # ne pas supprimer le mot 'probleme', il est recherche apres ..
		unlink($fich_PEERS) ;
		exit(1) ; } 

# pas de traitement d'erreurs pour NTPQ, car ceci est traite par un autre script,
# qui est plus important que ceclui ci ...
	
	# mise en forme diverses ...
	$cmd =~ s/^([\s]{1,})//g ;
	$cmd =~ s/([\s]{1,})/;/g ;
	$cmd =~ s/([\n]{1,})/;/g ;
	$cmd =~ s/([=]{2,})//g ;

	$cmd =~ s/([;]{2,})/;/g ;

	# traitement des symboles de relations NTP
	$cmd =~ s/([*]){1}/[PEER] /g ;
	$cmd =~ s/([+]){1}/[CANDIDATE] /g ;
	$cmd =~ s/([;]+[-]{1})+[a-z]/;[OUTLYER] /g ;
	$cmd =~ s/([#]){1}/[SELECTED] /g ;
	
#	print "$cmd ----> $fich_PEERS\n";

my $i = 0;  my $compt = 0;
my $retour = undef;

  #unlink ($fich_PEERS); # pas la peine., mais bon..

	# ouverture du fichier
	open (OUTFILE, "> $fich_PEERS") or
	die "Desole, impossible d'ecire dans $fich_PEERS...\n$!\n";

	my @retourCMD = split(/;/,$cmd) ;
	print OUTFILE "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";   #entete XML
	print OUTFILE "<peers>\n";
	foreach $retour (@retourCMD) {
		
		# la mise en forme XML
		switch($compt) { 
        case 0 { print OUTFILE "\t<server>\n\t\t<remote>".$retour."</remote>\n"; $compt++; }
        case 1 { print OUTFILE "\t\t<refid>".$retour."</refid>\n"; $compt++; }
        case 2 { print OUTFILE "\t\t<st>".$retour."</st>\n"; $compt++; }
        case 3 { print OUTFILE "\t\t<t>".$retour."</t>\n"; $compt++; }
        case 4 { print OUTFILE "\t\t<when>".$retour."</when>\n"; $compt++;}
        case 5 { print OUTFILE "\t\t<poll>".$retour."</poll>\n"; $compt++; }
        case 6 { print OUTFILE "\t\t<reach>".$retour."</reach>\n"; $compt++; }
        case 7 { print OUTFILE "\t\t<delay>".$retour."</delay>\n"; $compt++; }
        case 8 { print OUTFILE "\t\t<offset>".$retour."</offset>\n"; $compt++; }
        case 9 { print OUTFILE "\t\t<jitter>".$retour."</jitter>\n"; 
				$compt = 0 ; print OUTFILE "\t</server>\n"; }
    	}
	}
	print OUTFILE "</peers>\n"; # on ecris le tout


	close OUTFILE;   # fermeture du fichier

# fin main
# ----------------------------------------------------------------------
